@ECHO OFF
REM Update FW

REM ***************************** Config *****************************
REM BC_FILE_PATH: BC File Path
REM Set BC_FILE_PATH=
REM FW_FILE_PATH: FW File Path
REM Set FW_FILE_PATH= IAP\FW.ekt
REM Set FW_FILE_PATH= IAP\MASTER_FW.ekt;IAP\SLAVE1_FW.ekt
Set FW_FILE_PATH= IAP\GN15i00_HH_1117T00W02_20160318.ekt
Set Update_BC_Time= 10
REM WIN8_BRIDGE: 0:Elan bridge(0xb) \ 1:Win 8 or No Bridge 
Set WIN8_BRIDGE= 1
REM VDD(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ Other
Set VDD= 1
REM VIO(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ 4:1.8 \ Other
Set VIO= 1
REM I2C_Addr(Only use with Elan Bridge): 0x0 means set to default value 0x20.
Set I2C_Addr= 0x0
REM INTERFACE: 
REM USB or FastUSB:1 \ I2C or FastI2C:2 \SPI:3~6 \Hid over I2C: 8
REM 3: SPI SL(TP is MA Hi Rising Edge Out)
REM 4: SPI SL(TP is MA Hi Falling Edge Out)
REM 5: SPI MA(TP is SL Hi Rising Edge Out)
REM 6: SPI MA(TP is SL Hi Falling Edge Out)
Set INTERFACE= 1
REM NEW_IAP: Only used in I2C\Hid over I2C interface
Set NEW_IAP= 1
REM Master/Slave1/Slave2 Addr=0x20/0x40/0x42, Set 0x0 means not to update.
REM Only need to set MASTER_ADDR: 3900, Hid over I2C, and 3300 Lobyte(BootCodeVer)>=0x8A
REM Set SLAVE1_ADDR=0x40 if solution is 3915M I2C
Set MASTER_ADDR= 0x20
Set SLAVE1_ADDR= 0x0
Set SLAVE2_ADDR= 0x0
REM REK_DELAY_TIME(seconds): 0:No ReK \ >0:ReK after IAP
Set REK_DELAY_TIME= 3
REM STOP_TEST_FAILED_TIMES: Retry times while IAP or ReK failed.
REM It will not create log into NG folder, if retry success.
Set STOP_TEST_FAILED_TIMES= 3
REM WAITING_TIME_FOR_RETRY: Retry delay time (sec).
Set WAITING_TIME_FOR_RETRY= 3
REM ***************************** Config *****************************
Set PID= 0x0














title Elan IAP tool
IF %WIN8_BRIDGE% EQU 0 Set PARAM_BRIDGE_TYPE="-E"
IF %NEW_IAP% EQU 1 Set PARAM_NEW_IAP="-n"
set i=0
set f=0
set s=0
:LOOP
cls
set /a i=%i%+1
echo **************************** %i%-th IAP ***************************
echo **************************** %i%-th IAP *************************** >> AP\Log\Final_Result.txt
echo Start FW update Procedure
echo Start FW update Procedure >> AP\Log\Final_Result.txt
IF %INTERFACE% EQU 2 GOTO USB
AP\IAP.exe %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %FW_FILE_PATH% -c %PARAM_NEW_IAP%

GOTO RESULT
:USB
AP\IAP.exe %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p 0x0b -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %FW_FILE_PATH% -c %PARAM_NEW_IAP%

:RESULT
IF %ERRORLEVEL% EQU 1 GOTO FWDONE
GOTO FAILED

:FWDONE
set /a s=%s%+1
echo Update FW Success (Success= %s%, Failed= %f%)
echo Update FW Success (Success= %s%, Failed= %f%) >> AP\Log\Final_Result.txt
IF %REK_DELAY_TIME% GTR 0 Goto REK
GOTO END

:FAILED
set /a f=%f%+1
echo FAILED (Success= %s%, Failed= %f%) (err= %ERRORLEVEL%)
echo FAILED (Success= %s%, Failed= %f%) (err= %ERRORLEVEL%) >> AP\Log\Final_Result.txt
REM mkdir Log%f%
REM XCOPY /H /Q /Y Log\*.* Log%f%\*.*
echo %STOP_TEST_FAILED_TIMES%  >> AP\Log\Final_Result.txt
IF %f% GTR %STOP_TEST_FAILED_TIMES% GOTO END
echo Wait %WAITING_TIME_FOR_RETRY%s for retry
ping 123.45.67.89 -n %WAITING_TIME_FOR_RETRY% -w 1000 > nul
GOTO LOOP

:ReK
echo Delay %REK_DELAY_TIME%s for ReK...
ping 123.45.67.89 -n %REK_DELAY_TIME% -w 1000 > nul
echo ********************* Write Flash Key and ReK *********************
echo ********************* Write Flash Key and ReK ********************* >> AP\Log\Final_Result.txt
AP\IAP.exe -K %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -c
IF %ERRORLEVEL% EQU 1 GOTO REK_DONE

:REK_FAILED
echo FAILED (err= %ERRORLEVEL%)
echo FAILED (err= %ERRORLEVEL%) >> AP\Log\Final_Result.txt
GOTO END

:REK_DONE
echo SUCCESS
echo SUCCESS >> AP\Log\Final_Result.txt
GOTO END

:END

if not %errorlevel% equ 1 (
color c0
echo.
echo.
echo         ffffffff    ;ff:    ffffffff  ff       .ffffffff iffffff:              
echo         fftttttt    ffff    tttffttt  ff       .fttttttt ifttttff.             
echo         ff         tffffl      ff     ff       .f;       if     ff             
echo         ff         ff  ff      ff     ff       .f;       if     ff             
echo         ff        iff  ff;     ff     ff       .f;       if     ff             
echo         fffffff   ff    ff     ff     ff       .ffffff   if     ff             
echo         ff        ffffffff     ff     ff       .f;       if     ff             
echo         ff        ffffffff     ff     ff       .f;       if     ff             
echo         ff        ff    ff     ff     ff       .f;       if    :ff             
echo         ff        ff    ff  ffffffff  ffffffff .ffffffff ifffffff              
echo         ff        ff    ff  ffffffff  ffffffff .ffffffff iffffff        
echo. 
)

pause
